/******************** (C) COPYRIGHT 2019 SONiX *******************************
* COMPANY:		SONiX
* DATE:				2019/05
* AUTHOR:			SA1
* IC:					SN32F100
*____________________________________________________________________________
*	REVISION	Date				User		Description
*	1.0				2013/04/09	SA1			First release
*	2.0				2014/02/27	SA1			1. Update I2S functions.
*	3.0				2015/05/29	SA1			1. Compatible to CMSIS DFP Architecture in Keil MDK v5.X (http://www.keil.com/dd2/pack/)
*																2. Run HexConvert to generate bin file and show checksum after building.
*	4.0				2018/02/07	SA1			1. Add NotPinOut_GPIO_init to set the status of the GPIO which are NOT pin-out to input pull-up.
*																2. Add CodeOption_SN32F100.s to modify Code option, please modify with Configuration Wizard, 
*																	 and Strongly recommend to keep CS0 for debugging with SN-LINK.
*	4.1				2018/10/05	SA1			1. Remove CodeOption_SN32F100.s, please contact SONiX FAE if needed.
*	4.2				2019/05/31	SA1			1. Fix I2S_Master_Init and I2S_Slave_Init in I2S.c
*
*____________________________________________________________________________
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS TIME TO MARKET.
* SONiX SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL 
* DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH SOFTWARE
* AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN 
* IN CONNECTION WITH THEIR PRODUCTS.
*****************************************************************************/

/*_____ I N C L U D E S ____________________________________________________*/
#include <SN32F100.h>
#include <SN32F100_Def.h>
#include ".\Interface\I2S\I2S.h"


/*_____ D E C L A R A T I O N S ____________________________________________*/
void	NotPinOut_GPIO_init(void);

void I2S_Master_Irq(void);
void I2S_Slave_Irq(void);


/*_____ D E F I N I T I O N S ______________________________________________*/
#ifndef	SN32F109					//Do NOT Remove or Modify!!!
	#error Please install SONiX.SN32F1_DFP.1.0.2.pack or version >= 1.0.2
#endif
#define	PKG		SN32F109		//User SHALL modify the package on demand (SN32F109, SN32F108, SN32F107) 


uint32_t wI2S_Rx_Check=0x00A00000;
uint32_t wI2S_Tx_Data=0x00A00000;


/*_____ M A C R O S ________________________________________________________*/


/*_____ F U N C T I O N S __________________________________________________*/

/*****************************************************************************
* Function		: main
* Description	: This is I2s master Tx sample code, we can use this sample code to set I2S master Tx
								data length, channel length, FIFO level and MCLK div, Bitclk div...etc.
								I2S as master transfer data to slave and receive data from slave and compare Rx data
* Input			: None
* Output		: None
* Return		: None
* Note			: Connect DIN and DOUT 
*****************************************************************************/
int	main (void)
{
	//User can configure System Clock with Configuration Wizard in system_SN32F100.c
	SystemInit();
	SystemCoreClockUpdate();

	//1. User SHALL define PKG on demand.
	//2. User SHALL set the status of the GPIO which are NOT pin-out to input pull-up.
	NotPinOut_GPIO_init();

	//--------------------------------------------------------------------------
	//User Code starts HERE!!!

	//System Interface Init
	I2S_Master_Init();
	//I2S_Slave_Init();

	SN_I2S->TXFIFO = (wI2S_Tx_Data++);
	SN_I2S->TXFIFO = (wI2S_Tx_Data++);
	SN_I2S->TXFIFO = (wI2S_Tx_Data++);
	SN_I2S->TXFIFO = (wI2S_Tx_Data++);	

	//I2S interrupt enable
	I2S_Interrupt_Enable();	
	NVIC_ClearPendingIRQ(I2S_IRQn);
	NVIC_EnableIRQ(I2S_IRQn);
		
	__I2S_START;		//I2S start	
	
	while (1);			//Pass
}


/**************************************************************
* Function		: I2S_IRQHandler
* Description	: I2S as interrupt handler
* Input			: None
* Output		: None
* Return		: None
* Note			: None
****************************************************************/
__irq void I2S_IRQHandler(void)
{
	I2S_Master_Irq();
	//I2S_Slave_Irq();
}


/*****************************************************************************
* Function		: I2S_Master_Irq
* Description	: I2S master irq
* Input			: None
* Output		: None
* Return		: None
* Note			: None
*****************************************************************************/
void I2S_Master_Irq(void)
{
	uint32_t	wI2S_Read_Data;
	uint32_t  wI2S_Loop_Cnt=0;
	
	if(SN_I2S->RIS & mskI2S_TXFIFOOVIF)					//Tx overflow
	{												
		SN_I2S->IC = mskI2S_TXFIFOOVIC;		
		while(1);
	}
	else if(SN_I2S->RIS & mskI2S_TXFIFOTHIF)		//Tx threshold
	{									
		while(!(SN_I2S->STATUS & mskI2S_TXFIFOFULL))
		{
			SN_I2S->TXFIFO = (wI2S_Tx_Data++);
			if (wI2S_Tx_Data >= 0x00FFFFFF )		
			wI2S_Tx_Data = 0x00A00000;
		}	
		SN_I2S->IC = mskI2S_TXFIFOTHIC;		
	}
	else if(SN_I2S->RIS & mskI2S_RXFIFOUDIF)		//Rx underflow
	{									
		SN_I2S->IC = mskI2S_RXFIFOUDIC;
		while(1);
	}
	else if(SN_I2S->RIS & mskI2S_RXFIFOTHIF)		//Rx THreshold		
	{
		while(!(SN_I2S->STATUS & mskI2S_RXFIFOEMPTY))
		{
			wI2S_Read_Data = SN_I2S->RXFIFO;
 			if(wI2S_Read_Data != wI2S_Rx_Check)
			{
   			while(1);															//data compare error
			}
			wI2S_Rx_Check++;
			if(wI2S_Rx_Check >= 0x00FFFFFF)
			{
				wI2S_Loop_Cnt++;
				wI2S_Rx_Check = 0x00A00000;
			}
		}
		SN_I2S->IC = mskI2S_RXFIFOTHIC;
	}
}

/*****************************************************************************
* Function		: I2S_Slave_Irq
* Description	: I2S slave irq
* Input			: None
* Output		: None
* Return		: None
* Note			: None
*****************************************************************************/
void I2S_Slave_Irq(void)
{
	uint32_t	wI2S_Read_Data;
	uint32_t  wI2S_Loop_Cnt=0;
	
	if(SN_I2S->RIS & mskI2S_TXFIFOOVIF)					//Tx overflow	
	{											
		SN_I2S->IC = mskI2S_TXFIFOOVIC;
		while(1);
	}
	else if(SN_I2S->RIS & mskI2S_TXFIFOTHIF)		//Tx threshold
	{								

		while(!(SN_I2S->STATUS & mskI2S_TXFIFOFULL))
		{
			SN_I2S->TXFIFO = (wI2S_Tx_Data++);
			if(wI2S_Tx_Data >= 0x00FFFFFF)
			{
				wI2S_Tx_Data=0x00A00000;
			}
		}
		SN_I2S->IC = mskI2S_TXFIFOTHIC;		
	}
	else if(SN_I2S->RIS & mskI2S_RXFIFOUDIF)		//Rx underflow
	{								
	
		SN_I2S->IC = mskI2S_RXFIFOUDIC;
		while(1);
	}
	else if(SN_I2S->RIS & mskI2S_RXFIFOTHIF)		//Rx THreshold
	{							

		while(!(SN_I2S->STATUS & mskI2S_RXFIFOEMPTY))
		{
			wI2S_Read_Data = SN_I2S->RXFIFO;
			if(wI2S_Read_Data != wI2S_Rx_Check)
			{
				while(1);															//data compare error
			}
			wI2S_Rx_Check++;
			if(wI2S_Rx_Check >= 0x00FFFFFF)
			{
				wI2S_Loop_Cnt++;
				wI2S_Rx_Check = 0x00A00000;
			}
		}
		SN_I2S->IC = mskI2S_RXFIFOTHIC;
	}
}

/*****************************************************************************
* Function		: NotPinOut_GPIO_init
* Description	: Set the status of the GPIO which are NOT pin-out to input pull-up. 
* Input				: None
* Output			: None
* Return			: None
* Note				: 1. User SHALL define PKG on demand.
*****************************************************************************/
void	NotPinOut_GPIO_init(void)
{
#if (PKG == SN32F108)
	//set P0.8~P0.11 to input pull-up
	SN_GPIO0->CFG = 0xAA00AAAA;
	//set P1.2~P1.9 to input pull-up
	SN_GPIO1->CFG = 0xAAA0000A;
	//set P2.9~P2.15 to input pull-up
	SN_GPIO2->CFG = 0x0002AAAA;
#elif (PKG == SN32F107)
	//set P0.8~P0.11 to input pull-up
	SN_GPIO0->CFG = 0xAA00AAAA;
	//set P1.2~P1.9 to input pull-up
	SN_GPIO1->CFG = 0xAAA0000A;
	//set P2.2~P2.15 to input pull-up
	SN_GPIO2->CFG = 0x0000000A;
	//set P3.0~P3.1, P3.10~P3.13 to input pull-up
	SN_GPIO3->CFG = 0xA00AAAA0;
#endif
}

/*****************************************************************************
* Function		: HardFault_Handler
* Description	: ISR of Hard fault interrupt
* Input			: None
* Output		: None
* Return		: None
* Note			: None
*****************************************************************************/
__irq void HardFault_Handler(void)
{
	NVIC_SystemReset();
}

